# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..1\n"; $^W = 1 }
END {print "not ok 1\n" unless $loaded;}
use strict;
use vars qw($loaded);
use HTML::StyleStream;
use IO::Scalar;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

package MyStyle;
use vars qw(@ISA);
@ISA = qw(HTML::StyleStream::Plain);

sub H1 {
  my $self = shift;
  $self->SUPER::H1( ALIGN => 'center', @_ )
    ->FONT( COLOR => 'red' );
}

sub _H1 {
  shift->_FONT
    ->SUPER::_H1;
}

sub ASIDE {
  my($self, %attr) = @_;
  my $size = ($attr{SIZE} || '-1');
  $self->FONT( SIZE => $size )
    ->I;
  $self->start_save;
}

sub _ASIDE {
  my $self = shift;
  $self->end_save;
  $self->print("(", $self->last_saved_text, ")");
  $self->_I
    ->_FONT;
}

sub SILLY_TAG {
  my $self = shift;
  $self->i->SUPER::SILLY_TAG(@_);
}

sub _SILLY_TAG {
  shift->SUPER::_SILLY_TAG->_i;
}

sub foo {
  shift->print("!! foo called !!");
  return 42;
}

package main;

my $sty = new HTML::StyleStream;

$sty
  ->H1->text("Heading & Stuff")->_H1->nl
  ->H1( ALIGN => 'center' )->print("Heading &amp; Stuff")->_H1->nl
  ->H1->text("Heading ")->entity('amp')->text(" Stuff")->_H1->nl
  ->H1("Heading & Stuff")->nl
  ->H1( "Heading & Stuff", ALIGN => 'center' )->nl
  ->nl;

eval {
  $sty
    ->FOO("Test")->nl
    ->foo("Test")->nl;
};
warn $@ if $@;
$sty->nl;

$sty
  ->INPUT( TYPE => 'checkbox', NAME => 'foo', SELECTED => '' )->nl
  ->INPUT( TYPE => 'checkbox', NAME => 'foo', SELECTED => undef )->nl
  ->INPUT( TYPE => 'text', NAME => 'foo', VALUE => 'Text with "some quotes" in it')->nl
  ->nl;

$sty
  ->H1( ALIGN => 'center', ALIGN => 'left' )->text("Should be Left")->_H1->nl
  ->nl;

$sty
  ->tag("iNput", type => 'TEXT', NAME => 'foo', VaLuE => 'Text with "quotes"')->nl
  ->tag("h1")->text("Test")->tag("/h1")->nl
  ->tag("h1")->text("Test")->tag("_h1")->nl
  ->nl;

$sty->parse(<<"--END--")->eof->nl;
<HTML><head><TiTlE>This &amp; That</TiTlE></HEAD>
<body bgcolor=blue text=black bgcolor=white>
<h1>Hello</h1>
<input type=text name=foo value="Value &quot;with quotes&quot;">
--END--

$sty
  ->SILLY_TAG(SILLY_ATTR=>'val')->text("Foo")->_SILLY_TAG->nl
  ->tag("silly-tag", "siLly-attr" => 'val', silly_attr2=>'val2')->tag("SiLlY_TaG")->tag(".silly.tag")->nl
  ->parse("<SILLY-TAG SILLY-ATTR=val SILLY_ATTR2=val2>")->eof->nl
  ->nl;

undef $sty;

my $s;
my $sh = new IO::Scalar(\$s);
$sty = new HTML::StyleStream(output => $sh);
$sty->H1("Just a little test of outputting to a handle")->_H1->nl;
undef $sty;
print "\$s=\"$s\"\n\n";

$sty = new HTML::StyleStream(style => new MyStyle); 
$sty
  ->H1->text("Header 1")->_H1->nl
  ->H1("Header 1", ALIGN => 'left')->nl
  ->tag("h1")->tag("H1")->tag("h1", color => 'blue')->tag("h1", align => 'left')->nl
  ->parse("<H1>Header 1</H1><H1 ALIGN=left>Left Heading</H1>")->eof->nl
  ->parse("<foo>")->eof->nl
  ->ASIDE("aside")->ASIDE("small aside", SIZE=>'-2')->nl
  ->parse("<H1>Header 1</H1><ASIDE SIZE=+1>Big Aside</ASIDE>")->eof->nl
  ->nl;

my $r = $sty->foo(123);
print "foo retured $r\n";

undef $sty;

$sty = tie *H, 'HTML::StyleStream', style => new MyStyle;
print H "<H1>Test of output capture</H1>\n";
$sty->eof->ASIDE("Now using output methods")->nl;
print H "<ASIDE SIZE=-2>Back to output capture</ASIDE>\n";
$sty->eof->nl;
undef $sty;
untie *H;

print "Ok, it seems to work (but no guarantees :-))\n";

